# ----------------------------------------------------------------------------
# load_url.rb : サイトデータのロード処理
# ----------------------------------------------------------------------------

require 'mysql'
require 'constant'
require 'suzaku_lib'
include Suzaku

# 設定ファイルによる初期設定
f = ARGV.shift
cf = Config.new(f)

# 設定ファイルによる初期設定
host          = cf.parm["host"]
userid        = cf.parm["userid"]
password      = cf.parm["password"]
database      = cf.parm["database"]

# データベースのオープン
db = Mysql::new(host, userid, password, database)
db.query("SET NAMES utf8")

while line = STDIN.gets
  data = line.split(/\s*,\s*/, -1)
  url = data[0]
  category = data[1]
  name_kanji = data[2]
  name_kana = data[3]
  mail_address = data[4]
  comment = data[5]
  access = data[6]

# print "#{url},#{category},#{name_kanji},#{name_kana},#{mail_address},#{comment},#{access}\n"

  # insert url
  begin
    db.query("INSERT INTO url SET url_id=NULL,url='#{Mysql::quote url}',tree_level='1',registed=NOW(),response='000'")
  rescue MysqlError
    if $!.errno == 1062
      # 重複レコードの場合
      puts "skip: #{line}"
      next
    else
      raise
    end
  end
  # select url
  res2 = db.query("SELECT url_id FROM url WHERE url='#{Mysql::quote url}' AND tree_level='1'")
  res2.each do |url_id|
    # update url
    db.query("UPDATE url SET top_url_id=url_id WHERE url_id=#{url_id}")
    # insert information
    db.query("INSERT INTO information SET url_id=#{url_id},category='#{Mysql::quote category}',name_kanji='#{Mysql::quote name_kanji}',name_kana='#{Mysql::quote name_kana}',mail_address='#{Mysql::quote mail_address}',comment='#{Mysql::quote comment}',access=#{access}")
  end
end

# データベースのクローズ
db.close  
